#include <sml/ttkernel/c_api.h>
#include <pkgconf/ttkernel.h>
#include <stdio.h>

#include "ezs_fb.h"
#include "ezs_counter.h"
#include "ezs_trace.h"
#include <cyg/io/framebuf.h>
#include <cyg/io/framebufs/i386_fb.h>

//A little helper function
tt_ticktype ms_to_ticks(cyg_uint32 ms) {
	const cyg_uint64 delay_ns = ms * 1000000;
	const tt_ticktype ticks = (delay_ns * SMLNUM_TTKERNEL_RTC_NUMERATOR )/SMLNUM_TTKERNEL_RTC_DENOMINATOR;

	return ticks;
}

cyg_uint32 lose_ticks_per_ms=0;

// Declare Dispatcher table
tt_DispatcherTable(table1, 10);

// Declare task t1
tt_Task(t1){
	ezs_lose_time(2*lose_ticks_per_ms, 0); // 2ms wcet (+ printf)
	printf("Task1\n");
}

// Declare task t1
tt_Task(t2){
	ezs_lose_time(2*lose_ticks_per_ms, 0); // 2ms wcet (+ printf)
	printf("Task2\n");
}

// Idle task does nothing... 
ttIdleTask {
	while(1);
}


externC void cyg_user_start(){
	// Initialize framebuffer in graphic mode
	ezs_fb_init();
	// Initialize counter
	ezs_counter_init();
	cyg_uint32 lose_ms = 1;
	lose_ticks_per_ms = (lose_ms * 1000)/ezs_counter_resolution_us();

	printf("Time triggered!\r\n");
	// Initialize tasks with stringent deadline checking
	tt_InitTask(t1, TT_STRINGENT);
	tt_InitTask(t2, TT_STRINGENT);

	// Initialize dispatcher table
	tt_InitDispatcherTable(table1);
	// Don't forget to test if table is valid
	bool valid = 1;

	// Insert entries:
	valid &= tt_DispatcherTableEntry( table1, ms_to_ticks(0) , TT_START_TASK, t1 );
	valid &= tt_DispatcherTableEntry( table1, ms_to_ticks(9) , TT_DEADLINE  , t1 );
	valid &= tt_DispatcherTableEntry( table1, ms_to_ticks(10), TT_START_TASK, t1 );
	valid &= tt_DispatcherTableEntry( table1, ms_to_ticks(19), TT_DEADLINE  , t1 );

	if(!valid) {
		printf("WARNING: Table not valid!\n");
	}

	ttStartOS(table1);
}
